#!/usr/bin/python
'''
Created on May 20, 2013

@author: mwallers
'''

"""
input: NONE
output: NONE

along the way it records to file if the urls were found or not to the respective files,
the first record of file found or not found is always the Google answer if isGoogleVersion is enabled. 
furthermore, if the line begins with '-> ' then this line is the output of how the mobile did not follow 
	the rules that Google has set forth. 
"""

"""
TODO: add the main program part of this file that calls all the other parts (mediaqueries, useragent...)
"""

isCleanupOn = True

isDebug = False
from mobilefinder.util import request
from mobilefinder.util.record import record_notfound
from mobilefinder.pageProcessors import config
import mobilefinder.pageProcessors.differingURLs as differingURLs
import mobilefinder.pageProcessors.mediaQueries as mediaQueries
import mobilefinder.pageProcessors.userAgent as userAgent
import argparse
from mobilefinder.util import logger
import os
import sys
import stat
from time import time

'''
this function calls the 3 pageProcessors to analyze the page url given. 
this function goes through each processor and verifies that a mobile version was not found
before passing the desktop url to the next processor.
'''
def requestAllUrls(urls):
	os.chdir(os.path.dirname(os.path.realpath(__file__))) 
	fileLocation = os.path.join(sys.path[0], 'content/')
	print "filelocation in main is: " +fileLocation
	fixedDictionary = dict([('url','urlReturnedFromRequest')])  #ordering
	mobileDictionary = dict([('url','urlReturnedFromRequest')]) #ordering
	
	for url in urls:
		#request.requestPage(desktop, url)
		
		logger.log('main find %s ' % url, False)
		isFixed = True
		
		#make sure that the url starts with http:// or https://
		position = url.find('://')
		if position == -1:
			newURL = 'http://' + url  #add http:// as the beginning
			url = newURL
		logger.log('\trequesting fixed... ')
		needRepeat = True
		isFirstAttempt = True
		actuallySuccess = False
		while needRepeat:
			
			filename = ""
			#FIXED
			status = ""
			urlContent = None
			urlJs = []
			urlStylesheets = []
			urlHeaders = []
				
			if isFixed:
				if not isFirstAttempt:
					logger.log('\tre-attempting: requesting fixed... ', False)
				fixedStatus, fixedURL = request.requestPage('fixed', url)
				status = fixedStatus
				
				fixedDictionary[url] = fixedURL
				
				isError = False
				print "\tstarting the file opens"
				filename = config.getDomain(url, False, True) #********************************************************************
				filename = filename + "-fixed"
				filename = fileLocation + filename
			#MOBILE
			else:
				if not isFirstAttempt:
					logger.log('\tre-attempting: requesting mobile... ')
				mobileStatus, mobileURL = request.requestPage('mobile', url)
				status = mobileStatus
				
				mobileDictionary[url] = mobileURL
				
				filename = config.getDomain(url, False, True)  
				filename = filename + "-mobile"
				filename = fileLocation + filename
				
				
			try:
				
				filename2 = filename  + '.html'
				htmlfile = open(filename2, 'r')
				#print "\topening " + filename2
				urlContent = htmlfile.read()
				htmlfile.close()
				
				filename2 = filename + '.css'
				ssfile = open(filename2, 'r')
				#print "\topening " + filename2
				ssblock = ssfile.read()
				urlStylesheets = ssblock.split(',')
				ssfile.close()
				
				filename2 = filename  + '.js'
				jsfile = open(filename2, 'r')
				#print "\topening " + filename2
				jsblock = jsfile.read()
				urlJs = jsblock.split(',')
				jsfile.close()
				
				filename2 = filename + '.headers'
				headersfile = open(filename2, 'r')
				#print "\topening " + filename2
				urlHeaders = headersfile.readlines()
				headersfile.close()     

			except IOError as e:
				isError = True
				logger.log("error opening the fixed files...")
				print ("failed file name is: " , filename2)
				logger.log('\tfailed filename is '+filename2, False)
				print "I/O error({0}): {1}".format(e.errno, e.strerror)
				#if the file we broke on was NOT the html file
				if(filename2 != filename + '.html'): 
					isError = False
					needRepeat = False
					actuallySuccess = True
					print "actually a success"
			except:
				isError = True
				if fixedStatus == 'hang':  
					needRepeat = False
					logger.log ("\terror retrieving fixed page. status not success...", False)
					continue
				else:
					print "unexpected error"
					logger.log ("\tunexpected error!", False)
			else:
				needRepeat = False  #no errors occurred
				actuallySuccess = True
			
			#only want to repeat this once, not several times
			if isFirstAttempt:
				isFirstAttempt = False
				if not needRepeat and isFixed:#now repeat for mobile
					isFixed = False
					needRepeat = True
					isFirstAttempt = True
					isError = False
					print "\n mobile's turn"
			else:
				needRepeat = False
				if isFixed:  #now repeat for mobile
					isFixed = False
					needRepeat = True
					isFirstAttempt = True
					isError = False
					print "\n mobile turn"
				
		if isError:
			record_notfound(url, config.neverFoundFilename, None, None, True)
			#cleanup directories to make room:
			print "\terror url: "+url+"...\n"
			continue
	return fixedDictionary, mobileDictionary

def findMobileVersion(output_base, urls, time_file, fixedDictionary, mobileDictionary):
	remainingURLs = []
	os.chdir(os.path.dirname(os.path.realpath(__file__))) 
	fileLocation = os.path.join(sys.path[0], 'content/')
		#////////////////////////////////////////////////////////////////////////
	#then for useragent:
	print "------------------------------------------------"
	print "\nUSERAGENT:"

	config.foundFilename = open(os.path.join(output_base, 'useragent', 'found.txt'), 'a')
	config.notFoundFilename = open(os.path.join(output_base, 'useragent', 'notfound.txt'), 'a')
	config.statsFilename = open(os.path.join(output_base, 'useragent', 'stats.txt'), 'a')
	config.errorFilename = open(os.path.join(output_base, 'useragent', 'error.txt'), 'a')
	
	if config.isGoogleVersion:  #add in google version too?
		config.foundFilenameGoogleVersion = open(os.path.join(output_base, 'useragent', 'foundGoogle.txt'), 'a')
		config.notFoundFilenameGoogleVersion = open(os.path.join(output_base, 'useragent', 'notfoundGoogle.txt'), 'a')
		config.statsFilenameGoogleVersion = open(os.path.join(output_base, 'useragent', 'statsGoogle.txt'), 'a')
		config.errorFileNameGoogleVersion = open(os.path.join(output_base, 'useragent', 'errorGoogle.txt'), 'a')   
   
	isFound = False
	

	#start timer!
	start = time()

	#userAgent: 
	remainingURLs = userAgent.getMobileVersion(urls, fileLocation, fixedDictionary, mobileDictionary)
	if not remainingURLs: #no urls were returned as not having a mobile version found
		isFound = True

	elapsed=time()-start
	time_file.write('useragent %f\n' % elapsed)
	time_file.flush()
	logger.log('useragent done, elapsed time %fs' % elapsed)


	#Clean up
	(config.foundFilename).close()
	(config.notFoundFilename).close()
	(config.statsFilename).close()
	(config.errorFilename).close()
	
	if config.isGoogleVersion:  
		(config.foundFilenameGoogleVersion).close()
		(config.notFoundFilenameGoogleVersion).close()
		(config.statsFilenameGoogleVersion).close()
		(config.errorFileNameGoogleVersion).close()
		 
	'''
	if not isFound:
		print "-- remaining urls:  "
		for remurl in remainingURLs:
			print "\t" + remurl
	'''
		 
	#////////////////////////////////////////////////////////////////////////
	#then for mediaQueries:
	if not isFound:
		print "------------------------------------------------"
		print "\nMEDIA QUERIES:"
	
	config.foundFilename = open(os.path.join(output_base, 'mediaQueries', 'found.txt'), 'a')
	config.notFoundFilename = open(os.path.join(output_base, 'mediaQueries', 'notfound.txt'), 'a')
	config.statsFilename = open(os.path.join(output_base, 'mediaQueries', 'stats.txt'), 'a')
	config.errorFilename = open(os.path.join(output_base, 'mediaQueries', 'error.txt'), 'a')
	
	if config.isGoogleVersion:  
		config.foundFilenameGoogleVersion = open(os.path.join(output_base, 'mediaQueries', 'foundGoogle.txt'), 'a')
		config.notFoundFilenameGoogleVersion = open(os.path.join(output_base, 'mediaQueries', 'notfoundGoogle.txt'), 'a')
		config.statsFilenameGoogleVersion = open(os.path.join(output_base, 'mediaQueries', 'statsGoogle.txt'), 'a')
		config.errorFileNameGoogleVersion = open(os.path.join(output_base, 'mediaQueries', 'errorGoogle.txt'), 'a')  
		
	if not isFound:
		#mediaQueries
		start = time()
		remainingURLs = mediaQueries.getMobileVersion(remainingURLs, fileLocation)
		#remainingURLs = mediaQueries.getMobileVersion(urls, fileLocation)
		if not remainingURLs: #found mobile version in ss:
			isFound = True

		elapsed=time()-start
		time_file.write('media queries %f\n' % elapsed)
		time_file.flush()
		logger.log('mediaqueries done, elapsed time %fs' % elapsed)
			
	#Clean up
	(config.foundFilename).close()
	(config.notFoundFilename).close()
	(config.statsFilename).close()
	(config.errorFilename).close()
	
	if config.isGoogleVersion:  
		(config.foundFilenameGoogleVersion).close()
		(config.notFoundFilenameGoogleVersion).close()
		(config.statsFilenameGoogleVersion).close()
		(config.errorFileNameGoogleVersion).close()
	'''
	if not isFound:
		print "-- remaining urls:  "
		for remurl in remainingURLs:
			print "\t" + remurl
	'''
	#////////////////////////////////////////////////////////////////////////
	#then for differingURLS:
	if not isFound:
		print "------------------------------------------------"
		print "\nDIFFERING URLS:"

	config.foundFilename = open(os.path.join(output_base, 'differingURLs', 'found.txt'), 'a')
	config.notFoundFilename = open(os.path.join(output_base, 'differingURLs', 'notfound.txt'), 'a')
	config.statsFilename = open(os.path.join(output_base, 'differingURLs', 'stats.txt'), 'a')
	config.errorFilename = open(os.path.join(output_base, 'differingURLs', 'error.txt'), 'a')
	
	if config.isGoogleVersion:
		config.foundFilenameGoogleVersion = open(os.path.join(output_base, 'differingURLs', 'foundGoogle.txt'), 'a')
		config.notFoundFilenameGoogleVersion = open(os.path.join(output_base, 'differingURLs', 'notfoundGoogle.txt'), 'a')
		config.statsFilenameGoogleVersion = open(os.path.join(output_base, 'differingURLs', 'statsGoogle.txt'), 'a')
		config.errorFileNameGoogleVersion = open(os.path.join(output_base, 'differingURLs', 'errorGoogle.txt'), 'a')  
				 
	if not isFound: #still
		#differingURLs 
		start = time()
		remainingURLs = differingURLs.getMobileVersion(remainingURLs, fileLocation)
		#remainingURLs = differingURLs.getMobileVersion(urls, fileLocation)
		
		if  not remainingURLs:
			isFound = True
		elapsed=time()-start
		time_file.write('differing urls %f\n' % elapsed)
		time_file.flush()
		logger.log('differing URLs done, elapsed time %fs' % elapsed)
			
	#Clean up
	(config.foundFilename).close()
	(config.notFoundFilename).close()
	(config.statsFilename).close()
	(config.errorFilename).close()
	
	if config.isGoogleVersion:
		(config.foundFilenameGoogleVersion).close()
		(config.notFoundFilenameGoogleVersion).close()
		(config.statsFilenameGoogleVersion).close()
		(config.errorFileNameGoogleVersion).close()

	return remainingURLs


def cleanupUnusedDirectories(remainingUrls):	
	#os.chdir(os.path.dirname(os.path.realpath(__file__))) 
	
	fileLocationContent = os.path.join(sys.path[0], 'content/')
	fileLocationRender = os.path.join(sys.path[0], 'render/')
	for url in remainingUrls:
		filename = config.getDomain(url, False, True)
		
		folderName = filename[:filename.find('/')]
		print "foldername: " + fileLocationRender + folderName
		if os.path.exists(fileLocationRender + folderName):
			#print "removing folder: " + fileLocationRender + folderName
			os.system('rm -rf %s' % fileLocationRender + folderName )
		
		if os.path.exists(fileLocationContent + folderName):
			#print "removing folder: " + fileLocationContent + folderName
			os.system('rm -rf %s' % fileLocationContent + folderName )
		
		
def giveWorldPermissions(urls):	
	os.chdir(os.path.dirname(os.path.realpath(__file__))) 
	
	fileLocationContent = os.path.join(sys.path[0], 'content/')
	fileLocationRender = os.path.join(sys.path[0], 'render/')
	for url in urls:
		try:
			filename = config.getDomain(url, False, True)
			
			folderName = filename[:filename.find('/')]
			#print "foldername: " + fileLocationRender + folderName
			if os.path.exists(fileLocationRender + folderName):
				#print "changing permissions of folder: " + fileLocationRender + folderName
				directoryName = fileLocationRender + folderName
				os.chmod(directoryName, 0o757) #set writing for others
				for root,dirs,files in os.walk(directoryName):
					for f in files :
						os.chmod(directoryName + "/" + f , 0o646)
			
			if os.path.exists(fileLocationContent + folderName):
				#print "removing folder: " + fileLocationContent + folderName
				directoryName = fileLocationContent + folderName
				os.chmod(directoryName, 0o757) #set writing for others
				for root,dirs,files in os.walk(directoryName):
					for f in files :
						os.chmod(directoryName + "/" + f , 0o646)
		except:
			continue  #means another owner created the file so we cannot change it. it already has write priveledges
'''
This function takes care of input arguments and sets up the output text files and folder to store the job in.
Then it calls the funciton findMobileVersion() to begin finding the mobile versions.
'''
def main():    
	#Input
	parser=argparse.ArgumentParser(description='System for finding mobile versions of web pages.',
								   epilog='URLs will be read from stdin if no file is specified')
	
	parser.add_argument('-j', '--job-name',
						help='name of job, output will be placed in jobs/[job name]')

	
	parser.add_argument('-f', '--file',
						type=argparse.FileType('r'),
						help='input file, should be a list of URLs')
						
	parser.add_argument('-u', '--url',
						help='a single url as input to run the script on.')
	
	parser.add_argument('-a', '--userAgent',
						help='a specific mobile useragent to use instead of the default one.')
						
	parser.add_argument('-q', '--quiet',
						action='store_true',
						help='do not write logging output to stderr')

	parser.add_argument('-g', '--GoogleVersionDisabled',
						action='store_false',
						help='disable checking mobile pages against the guidelines that Google set')
						
	parser.add_argument('-y', '--automaticYes',
						action='store_true',
						help='automatically answer all questions about overwriting files with yes')
						
	parser.add_argument('-n', '--automaticNo',
						action='store_true',
						help='automatically answer all questions about overwriting files with no')
						
	args=parser.parse_args()
	
	logger.stderr_enabled=not args.quiet
	
	config.isGoogleVersion = True
	if not args.GoogleVersionDisabled:
		config.isGoogleVersion = False

	job_name=args.job_name
	while not job_name:
		job_name=raw_input('Job name: ')

	if args.userAgent:
		config.mobileUserAgent = args.userAgent
	
	urls=[]
	if args.file:
		#...from file
		for line in args.file:
			if line[0]=='#':
				continue
			urls.append(line.strip())
	elif args.url:
		urls.append(args.url)
	else:
		#...from stdin
		while True:
			try:
				urls.append(raw_input())
			except EOFError:
				break
	
	#Set up output directory
	os.chdir(os.path.dirname(os.path.realpath(__file__)))    
			
	output_base=os.path.join(sys.path[0], 'jobs', job_name)
	if not args.automaticNo:
		try:
			os.mkdir(os.path.join(sys.path[0], 'jobs'))
		except:
			pass
		
		try:
			os.mkdir(output_base)
		except OSError as e:
			print e
			if not args.automaticYes:
				entry=raw_input('Job %s already exists, overwrite? (y/n) ' % job_name)
				while ( not entry == 'y' and not entry == 'Y' ) and ( not entry == 'n' and not entry == 'N' ):    
					entry=raw_input('\tPlease only enter "y" or "n": ')
				if entry=='y' or entry == 'Y':
					os.system('rm -fr %s' % output_base)
					os.mkdir(output_base)
			else:
				print "attempting to remove directory and remake it..."
				os.system('rm -fr %s' % output_base)
				os.mkdir(output_base)
				
	logger.log_file=open(os.path.join(output_base, 'log.txt'), 'a')
	time_file=open(os.path.join(output_base, 'time.txt'), 'a')
		
		
	'''
		goes through calling all 3 processors and writing the results out twice: once for original version and once for Google rules version
		this is because they will need to write to different files and the Google version will cut out early and so looping through everything
		twice is required anyways. it's best to have main control the looping through of everything. 
	'''
	if not args.automaticNo:
		#Setup
		try:
			os.mkdir(os.path.join(output_base, 'useragent'))
		except OSError:
			if not args.automaticYes:
				entry=raw_input('useragent folder detected, overwrite? (y/n) ')
				while ( not entry == 'y' and not entry == 'Y' ) and ( not entry == 'n' and not entry == 'N' ): 
					entry=raw_input('\tPlease only enter "y" or "n": ')
				if entry=='y' or entry == 'Y':
					os.system('rm -fr %s' % os.path.join(output_base, 'useragent'))
					os.mkdir(os.path.join(output_base, 'useragent'))
			else:
				os.system('rm -fr %s' % os.path.join(output_base, 'useragent'))
				os.mkdir(os.path.join(output_base, 'useragent'))
		#Setup
		try:
			os.mkdir(os.path.join(output_base, 'mediaQueries'))
		except OSError:
			if not args.automaticYes:
				entry=raw_input('mediaQueries folder detected, overwrite? (y/n) ')
				while ( not entry == 'y' and not entry == 'Y' ) and ( not entry == 'n' and not entry == 'N' ): 
					entry=raw_input('\tPlease only enter "y" or "n": ')
				if entry=='y' or entry == 'Y':
					os.system('rm -fr %s' % os.path.join(output_base, 'mediaQueries'))
					os.mkdir(os.path.join(output_base, 'mediaQueries'))
			else:
				os.system('rm -fr %s' % os.path.join(output_base, 'mediaQueries'))
				os.mkdir(os.path.join(output_base, 'mediaQueries'))
				
		#Setup
		try:
			os.mkdir(os.path.join(output_base, 'differingURLs'))
		except OSError:
			if not args.automaticYes:
				entry=raw_input('differingURLs folder detected, overwrite? (y/n) ')
				while ( not entry == 'y' and not entry == 'Y' ) and ( not entry == 'n' and not entry == 'N' ): 
					entry=raw_input('\tPlease only enter "y" or "n": ')
				if entry=='y' or entry == 'Y':
					os.system('rm -fr %s' % os.path.join(output_base, 'differingURLs'))
					os.mkdir(os.path.join(output_base, 'differingURLs'))
			else:
				os.system('rm -fr %s' % os.path.join(output_base, 'differingURLs'))
				os.mkdir(os.path.join(output_base, 'differingURLs'))
			
	print "\n*****************ORIGINAL AND GOOGLE VERSIONS COMBINED*****************"
	#call the function to handle the processors:
	#remianingURLs are the urls that never had a mobile version found after all the processors tried
	config.neverFoundFilename = open(os.path.join(output_base, 'notfoundFINAL.txt'), 'a')
	remainingURLs = urls
	print "\n-------------------------REQUESTING ALL URLS --------------------------------"
	fixedDictionary, mobileDictionary = requestAllUrls(urls)	
	print "\n---------------------CALLING FIND MOBILE VERSION-----------------------------"
	remainingURLs = findMobileVersion(output_base, urls, time_file, fixedDictionary, mobileDictionary)
	if not remainingURLs:
		print "\n\nEND RESULT: no remaining urls"
	else:    
		print "\n\nEND RESULT: "    
		for url in remainingURLs:
			   print "\t" + url
			   record_notfound(url, config.neverFoundFilename, None, None, True)
  
	(config.neverFoundFilename).close()
	
	#only clean up if this variable is set
	#if isCleanupOn:
	#	cleanupUnusedDirectories (remainingURLs)
	#giveWorldPermissions(urls)
		
	logger.log_file.close()
	time_file.close()
	
			
#works only if the program is run from this module        
if __name__ == '__main__':
	main()  
