
'''
Created on May 20, 2013

@author: mwallers
'''

"""
input: NONE
output: NONE

along the way it records to file if the urls were found or not to the respective files
"""

"""
TODO: add the main program part of this file that calls all the other parts (mediaqueries, useragent...)
"""
"""
#import statements:
#from pageProcessors.config import isGoogleVersion
from pageProcessors import config
from util.request import requestPage
import pageProcessors.differingURLs as differingURLs
import pageProcessors.mediaQueries as mediaQueries
import pageProcessors.userAgent as userAgent
import argparse
from util import logger
import os
import sys

'''
this function calls the 3 pageProcessors to analyze the page url given. 
this function goes through each processor and verifies that a mobile version was not found
before passing the desktop url to the next processor.
'''
def findMobileVersion(url, content, headers, js, inlineJs, stylesheets):
    isFound = False
    #TODO: what about checking if a difference exists???? responsible within useragent and differingurls?
    
    #userAgent:
        #try differing user agents 
    mobileURL = userAgent.getMobileVersion(url, content, headers) #CHANGE to the correct arguments
    
    if mobileURL != "": #found mobile page and valid page was returned
        isFound = True
            
    if not isFound:
        #mediaQueries

        mobileFound = mediaQueries.getMobileVersion(url, content, stylesheets) #CHANGE to the correct arguments
        
        if mobileFound: #found mobile version in ss:
            isFound = True
            
    if not isFound: #still
        #differingURLs attempts
        mobileURL = differingURLs.getMobileVersion(url, content) #CHANGE to the correct arguments
        
        if  mobileURL != "": #found mobile page and valid page was returned
            isFound = True
            
    if isFound:
        return mobileURL
    return ""

def main():
    #TODO: the input arguments from cmd line stuff goes here (the argument parsing)
    
    #Input
    parser=argparse.ArgumentParser(description='System for finding mobile versions of web pages.',
                                   epilog='URLs will be read from stdin if no file is specified')
    
    parser.add_argument('-j', '--job-name',
                        help='name of job, output will be placed in jobs/[job name]')

    
    parser.add_argument('-f', '--file',
                        type=argparse.FileType('r'),
                        help='input file, should be a list of URLs')
    
    parser.add_argument('-q', '--quiet',
                        action='store_true',
                        help='do not write logging output to stderr')
    
    args=parser.parse_args()
    
    logger.stderr_enabled=not args.quiet
    
    
    #WANT TO KEEP??
    job_name=args.job_name
    while not job_name:
        job_name=raw_input('Job name: ')
        
    
    
    #TODO:load the URLs (10K) from file if file exists or from stdin
    
    urls=[]
    if args.file:
        #...from file
        for line in args.file:
            if line[0]=='#':
                continue
            urls.append(line.strip())
    else:
        #...from stdin
        while True:
            try:
                urls.append(raw_input())
            except EOFError:
                break
    
    
    '''what richard had in his main.py:'''
    #Set up output directory
    os.chdir(os.path.dirname(os.path.realpath(__file__)))    
            
    output_base=os.path.join(sys.path[0], 'jobs', job_name)
    
    try:
        os.mkdir(os.path.join(sys.path[0], 'jobs'))
    except:
        pass
    
    try:
        os.mkdir(output_base)
    except OSError as e:
        print e
        entry=raw_input('Job %s already exists, overwrite? (y/n) ' % job_name)
        
        if entry=='y':
            os.system('rm -fr %s' % output_base)
            os.mkdir(output_base)
            
    logger.log_file=open(os.path.join(output_base, 'log.txt'), 'a')
    time_file=open(os.path.join(output_base, 'time.txt'), 'a')
    
    
    #then for useragent:
    #Setup
    try:
        os.mkdir(os.path.join(output_base, 'useragent'))
    except OSError:
        entry=raw_input('useragent folder detected, overwrite? (y/n) ')
        if entry=='y':
            os.system('rm -fr %s' % os.path.join(output_base, 'useragent'))
            os.mkdir(os.path.join(output_base, 'useragent'))
    
    config.foundFilename = open(os.path.join(output_base, 'useragent', 'found.txt'), 'a')
    config.notFoundFilename = open(os.path.join(output_base, 'useragent', 'notfound.txt'), 'a')
    config.statsFilename = open(os.path.join(output_base, 'useragent', 'stats.txt'), 'a')
    config.errorFilename = open(os.path.join(output_base, 'useragent', 'error.txt'), 'a')
    
    config.foundFilenameGoogleVersion = open(os.path.join(output_base, 'useragent', 'foundGoogle.txt'), 'a')
    config.notFoundFilenameGoogleVersion = open(os.path.join(output_base, 'useragent', 'notfoundGoogle.txt'), 'a')
    config.statsFilenameGoogleVersion = open(os.path.join(output_base, 'useragent', 'statsGoogle.txt'), 'a')
    config.errorFileNameGoogleVersion = open(os.path.join(output_base, 'useragent', 'errorGoogle.txt'), 'a')   
        
            

    for url in urls:
        stylesheets = []
        inlineJs = []
        js = []
        headers = []
        #get content for desktop page via request.coffee
        status, finalURL, content, headers, stylesheets, js, inlineJs = requestPage('fixed', url, False) #from request.coffee....or something
                
                ###TODO: save the headers, js, css, content, etc... 
        
        mobile = findMobileVersion(url, content, headers, js, inlineJs, stylesheets)
            #--> use the 3 methods
            
            
        #detemine what to do with the returned mobile version of the fixed url       
            
        ###TODO: set the file names to actual values associated with the right folders. Then OPEN them and pass the filehandles?? or make config have the filehandles!?       
            #meaning if this is the program that is run initially to call all else
            
   
    #Clean up
    (config.foundFilename).close()
    (config.notFoundFilename).close()
    (config.statsFilename).close()
    (config.errorFilename).close()
    (config.foundFilenameGoogleVersion).close()
    (config.notFoundFilenameGoogleVersion).close()
    (config.statsFilenameGoogleVersion).close()
    (config.errorFileNameGoogleVersion).close()
         
    ''''''''
        
#works only if he program is run from this module        
if __name__ == '__main__':
    #want to keep the files at config.py's defaults for them?????
       
    isGoogleVersion = False  #at first
    main()  #dont need to pass it since it is GLOBAL variable
    isGoogleVersion = True
    main() #called twice to do everything again but with the google version. this allows the user to pick one or the other or possibly do both
    
    """