'''
Created on May 20, 2013
Changed from backup on 6/27/2013
@author: mwallers
'''
"""
input: fixed (desktop) url, mobile url, fixed content, mobile content  (change to filenames where content stored????)
output: bool isDifferent

This script will take the contents that were downloaded from the desktop page and the mobile page and it will
compare them and see what the score returned is. This is done several times and the mean score and standard
deviation are calculated and then those are used to determine if the mobile page is different enough from the
average download of a desktop page to warrant being classified as the official mobile version of the desktop page.

"""
from numpy import mean, std
from logger import log
from TFDA import TFDA
from request import requestPage
from ..pageProcessors.config import getDomain
COMPARE_COPIES=7

#It fits into the processors cleanly enough
score=None
def get_last_score():
    return score


def differenceExists(fixedURL, fixedContent, fixedStylesheets, fixedJs, mobileURL, mobileContent, mobileStylesheets, mobileJs, fileLocation, fixedInlineJs = None, mobileInlineJs = None):
    #compare the html content, compare the stylesheets, and compare the js (inline and external) even if need be
    #if above threshold (2 standard deviations away from the mean) then difference exists

    #Score the difference
    global score
    score=TFDA(fixedContent, mobileContent)
    
    #If there's no difference, I guess there's no difference
    if score==0:
        return False
    
    #Request copies of the desktop page
    log('\trequesting copies... ', False)
    
    scores=[]
    for i in range(COMPARE_COPIES):
        log('%d... ' % (i+1), False)
        
        status, _ =requestPage('fixed', fixedURL)
                
        filename = getDomain(fixedURL, False, True)  
                
        try:
            filename = fileLocation + filename
            contentfile = open(filename + '-fixed.html', 'r')
            copyContent = contentfile.read()
            contentfile.close()
        except:
            log("\tCannot open files correctly...", False)
            status = 'fail'
        else:
		   status = 'success'  #since phantomJs can return false fails to where the status is fail but the content is all there and working
		   
        if status=='success':
            #Score the difference between the original
            #desktop page and the copy
            scores.append(TFDA(fixedContent, copyContent))
        else:
            log(' TIMEOUT ', False)
    log('')
    
    #get the mean and standard deviation of the copy scores
    m=mean(scores)
    s=std(scores)
    
    log('\t\tmean = %f' % m)
    log('\t\tstd  = %f' % s)
    log('\t\ttfda = %f' % score)
    
    #If the score of the mobile page is two standard deviations above
    #the mean, we'll consider it a significant difference.
    if score>m+s+s:
        log('\t\tsignificant difference')
        return True
    else:
        log('\t\tinsignificant difference')
        return False