'''
Created on May 20, 2013

@author: mwallers
'''

"""
input: user agent ("fixed" or "mobile"), url
output:status, finalURL. all else saved to file (image, html content, ss, js, headers)

image = along the way it saves the image of the rendered page at the url finalURL 
"""
FILE_LOCATION = '/home/mwallers/'

#from ..pageProcessors.config import getDomain, mobileUserAgent
from subprocess import Popen, PIPE
from timeoutTaz import set_timeout, TimeoutException
import os
import sys
TIMEOUT=45
mobileUserAgent = ""

def getDomain(url, keepSlashes = True, appendFolder = False):
	domain = ""
	if 'http://' in url:
		domain = url.replace('http://', '')
	elif 'https://' in url:
		domain = url.replace('https://', '')
	if 'www' in domain:
		domain = domain.replace('www.', '')
	
	if not keepSlashes:  #then get rid of '/' onwards
		position = domain.find('/')
		if position > 0:
			domain = domain[:position]
	
	if appendFolder: #used for where request saves the files
		filename = domain
		position = filename.find('.')
		filefolder = filename
		if position >= 0:
			filefolder = filename[:position]
		
		filename = filefolder + "/" + filename  #TODO: fix this to forward slashes when going to taz
		domain = filename
		if domain[len(domain) -1] == '/':
			domain = domain[:len(domain)-1]		
	return domain
	
@set_timeout(TIMEOUT)	
def requestPage(useragent, url, urlForFilename=None):
	"""
	useragent: "desktop" or "mobile"
	url: the url to request
	stylesheets: whether to include a list of stylesheet URLs
	
	Returns a tuple of the final status of the request, the final url
	(after redirects, etc.), and the content of the request.
	
	"""
	status, final_url = None, None

	filename = ""
	if urlForFilename:
		filename = urlForFilename 
	else:
		filename = getDomain(url, False, True)
		
	#check if folder already exists.
	#if it does then delete the contents so request.coffeee can add in the new images and content
	'''
	directory = os.path.dirname(os.path.realpath(__file__))
	position = directory.find('MobileFinder/') + len('MobileFinder/')
	folderDirectory = directory[:position]
	newFilename = filename + "-" + useragent
	print folderDirectory + 'content/' + newFilename
	if os.path.exists(folderDirectory + 'content/' + newFilename):
		print "REMOVING : " + folderDirectory + 'content/' + newFilename #os.system('rm -fr %s' % folderDirectory + 'content/' + newFilename)
		
	'''
	#print "\n\n" + FILE_LOCATION + 'phantomjslinux/phantomjs-1.9.2-linux-x86_64/bin/phantomjs\n';
	#print "\n\n" + FILE_LOCATION+'MobileFinder/requestTaz.coffee\n'
	#print "creating files i hope\n\n"
	print "executing phantomjs. filename in request.py is " + filename
	if not mobileUserAgent == "":
		process=Popen((FILE_LOCATION + 'phantomjslinux/phantomjs-1.9.2-linux-x86_64/bin/phantomjs',  FILE_LOCATION+'NewMobileFinder/requestTaz.coffee', useragent, url, filename, mobileUserAgent), stdout=PIPE)
	else:
		process=Popen((FILE_LOCATION+'phantomjslinux/phantomjs-1.9.2-linux-x86_64/bin/phantomjs',  FILE_LOCATION+'NewMobileFinder/requestTaz.coffee', useragent, url, filename), stdout=PIPE)
	try:  
		(stdo, stde) = process.communicate()
		values = []
		values = stdo.split('\n')
		#print "\n\t\t\tSTANDARD OUT GAVE ME: " + stdo
		#print "\t\tEND STANDARD OUT"
		if values and len(values) > 1:
			status, final_url= values[0], values[1]
			print "got values: " + status +" and "+final_url
			statusSet = False
			for value in values:
				if statusSet == True:
					final_url = value
					statusSet = False  #so it is only set once
				if value == "success":
					status = value
					statusSet = True
			if statusSet:
				print "reset values: " + status +" and "+final_url
		else:
			status, final_url = 'fail', ''
		if stde:
			print "\t\t\tSTANDARD ERROR GAVE ME: " + stde
		#status, final_url =_phantom_request(process)
	except TimeoutException:
		status='hang'
		process.kill()
		print "killed phantomjs process."
	print "done with phantomjs"
	return status, final_url

@set_timeout(TIMEOUT)
def _phantom_request(process):
	status=process.stdout.readline().strip()
	final_url=process.stdout.readline().strip()
	
	return status, final_url

if __name__ == '__main__':
	useragent = 'fixed'
	url = 'http://www.dotmobi.com'
	#filespot = 'msn2/msn'
	print FILE_LOCATION+"MobileFinder/files/"
	print "beginning fixed...\n\n"
	status, finalURL = requestPage(useragent, url)#, FILE_LOCATION+"MobileFinder/files/")
	if not status:
		print "FIXED-- no success status, no finalurl"
	print "FIXED-- status: "+ status + ".\tfinal url: "+finalURL
	useragent = 'mobile'
	print "beginning mobile...\n\n"
	status, finalURL = requestPage(useragent, url)#, FILE_LOCATION+"/MobileFinder/files/")
	if not status:
		print "MOBILE-- no success status, no finalurl"
	print "MOBILE-- status: "+ status + ".\tfinal url: "+finalURL

