#Import filesystem module
fs = require('fs')

#Chromium
FIXED_UA="Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/535.19 (KHTML, like Gecko) Ubuntu/12.04 Chromium/18.0.1025.151 Chrome/18.0.1025.151 Safari/535.19 (compatible; PhantomJS/1.5.0; +http://cs.harding.edu)"

#iPhone
MOBILE_UA="Mozilla/5.0 (iPhone; U; CPU iPhone OS 4_1 like Mac OS X; en-us) AppleWebKit/532.9 (KHTML, like Gecko) Version/4.0.5 Mobile/8B117 Safari/6531.22.7 (compatible; PhantomJS/1.5.0; +http://cs.harding.edu)"



page = require('webpage').create();
system = require('system')

if system.args.length<3 or system.args.length > 5
	console.log "Usage: phantomjs request.coffee [fixed|mobile] url (optional: filename)"
	phantom.exit()

userAgent=null
if system.args[1]=='fixed' or system.args[1]=='desktop'
	userAgent=FIXED_UA
	page.viewportSize={'width': 1280, 'height': 800}
else if system.args[1]=='mobile'
	userAgent=MOBILE_UA
	page.viewportSize={'width': 320, 'height': 480}
else
	console.log "Unknown user agent"
	phantom.exit()
if userAgent == MOBILE_UA and system.args.length == 5
	userAgent = system.args[4]

page.settings.userAgent=userAgent
#NOTE: changed to load images here
page.settings.loadImages=true
	
url=system.args[2]
#CSS awareness
css_files=[]
js_files = []
headers = []
isFirstTime = 0

filename = ""
if system.args.length >3
	filename = system.args[3]

#warning: be careful of .value vs .name for searching through the response headers below
page.onResourceReceived = (response) ->  	
	i = 0	
	while i < response.headers.length
		if response.headers[i].name == 'Vary' 
			if response.headers[i].value.indexOf('User-Agent') >= 0  #will print only the vary http headers
				#console.log "\n" + response.headers[i].name + ": " + response.headers[i].value
				headers.push response.headers[i].name + ": " + response.headers[i].value
		#look in contentType for the css and js files. later mediaQueries can look in content for more
		if /text\/css/i.test(response.contentType)
			css_files.push response.url
			#console.log "SS: " + response.url
		if /text\/javascript/i.test(response.headers[i].value) or  /application\/javascript/i.test(response.headers[i].value)  #this will also get script unfortunately i think... 
			js_files.push response.url
			#console.log "JS: " + response.url
		i++ 
	
	
#console.log "Getting the current address now"
page.open url, (status) ->
	#Print status, final URL, and content
	console.log status
	console.log page.evaluate 'function(){return window.location.toString();}'
	
	#Record the page for later purposes
	urlStem=url.replace('http://', '')
	urlStem=urlStem.replace('www.', '')
	#console.log 'content/'+urlStem+'-'+system.args[1]+'.html'
	#console.log 'content/'+filename+'-'+system.args[1]+'.html'
	#console.log filename
	#location = page.evaluate 'function(){return window.location.pathname.toString();}'
	
	fileLocation = '/home/mwallers/NewMobileFinder/content/'
	fileLocationImage = '/home/mwallers/NewMobileFinder/render/'
	if filename == ""
		fs.write(fileLocation+urlStem+'-'+system.args[1]+'.html', page.content, 'w')
		page.render(fileLocationImage+urlStem+'-'+system.args[1]+'.png')
		fs.write(fileLocation+urlStem+'-'+system.args[1]+'.css', css_files, 'w')
		fs.write(fileLocation+urlStem+'-'+system.args[1]+'.js', js_files, 'w')
		fs.write(fileLocation+urlStem+'-'+system.args[1]+'.headers', headers, 'w')
		console.log "done. saving to: " +fileLocation+urlStem+"-"+system.args[1]+".html"

	else		
		fs.write(fileLocation+filename+'-'+system.args[1]+'.html', page.content, 'w')
		page.render(fileLocationImage+filename+'-'+system.args[1]+'.png')
		fs.write(fileLocation+filename+'-'+system.args[1]+'.css', css_files, 'w')
		fs.write(fileLocation+filename+'-'+system.args[1]+'.js', js_files, 'w')
		fs.write(fileLocation+filename+'-'+system.args[1]+'.headers', headers, 'w')
		console.log "done with filename. saving to: " +fileLocation+filename+"-"+system.args[1]+".html"
	phantom.exit()